/**
 * postal - Pub/Sub library providing wildcard subscriptions, complex message handling, etc.  Works server and client-side.
 * Author: Jim Cowart (http://ifandelse.com)
 * Version: v2.0.6
 * Url: http://github.com/postaljs/postal.js
 * License(s): MIT
 */
(function(e,t){var n={after:require("lodash/after"),some:require("lodash/some"),bind:require("lodash/bind"),debounce:require("lodash/debounce"),each:require("lodash/each"),extend:require("lodash/assign"),filter:require("lodash/filter"),isEqual:require("lodash/isEqual"),keys:require("lodash/keys"),map:require("lodash/map"),throttle:require("lodash/throttle")};"function"==typeof define&&define.amd?define(function(){return t(n,e)}):"object"==typeof module&&module.exports?module.exports=t(n,this):e.postal=t(n,e)})(this,function(e,t,n){function i(){for(;y.length;)h.unsubscribe(y.shift())}function r(e,t,n){return function(i,r,c){i===e&&c.splice(r,1),0===c.length&&delete n[t]}}function c(e,t,n,i,r){var c=r&&r.headers||{};return function(r){var o;l.resolver.compare(r.topic,e,c)&&(c.resolverNoCache||(o=t[n]=t[n]||[],o.push(r),r.cacheKeys.push(n)),i&&i(r))}}function o(e,t){return{channel:l.SYSTEM_CHANNEL,topic:"subscription."+e,data:{event:"subscription."+e,channel:t.channel,topic:t.topic}}}function s(t,n){return"function"==typeof t?t:t?function(i){var r=0,c=0;return e.each(t,function(e,o){r+=1,("topic"===o&&n.compare(i.topic,t.topic,{resolverNoCache:!0})||"context"===o&&t.context===i._context||i[o]===t[o])&&(c+=1)}),r===c}:function(){return!0}}var a=t&&t.postal,u={DEFAULT_CHANNEL:"/",SYSTEM_CHANNEL:"postal",enableSystemMessages:!0,cacheKeyDelimiter:"|",autoCompactResolver:!1},h={configuration:e.extend({},u)},l=h.configuration,f=function(e,t){this.bus=t,this.channel=e||l.DEFAULT_CHANNEL};f.prototype.subscribe=function(){return this.bus.subscribe({channel:this.channel,topic:1===arguments.length?arguments[0].topic:arguments[0],callback:1===arguments.length?arguments[0].callback:arguments[1]})},f.prototype.publish=function(){var t,n={};if("string"==typeof arguments[0]?(n.topic=arguments[0],n.data=arguments[1],t=arguments[2]):(n=arguments[0],t=arguments[1]),"object"!=typeof n)throw new Error("The first argument to ChannelDefinition.publish should be either an envelope object or a string topic.");n.headers=e.extend(n.headers||{resolverNoCache:l.resolverNoCache}),n.channel=this.channel,this.bus.publish(n,t)};var p=function(e,t,i){if(3!==arguments.length)throw new Error("You must provide a channel, topic and callback when creating a SubscriptionDefinition instance.");if(0===t.length)throw new Error("Topics cannot be empty");this.channel=e,this.topic=t,this.callback=i,this.pipeline=[],this.cacheKeys=[],this._context=n},b=function(){var t;return function(n){var i=!1;return"string"==typeof n?(i=n===t,t=n):(i=e.isEqual(n,t),t=e.extend({},n)),!i}},d=function(){var t=[];return function(n){var i=!e.some(t,function(t){return e.isEqual(n,t)});return i&&t.push(n),i}};p.prototype={"catch":function(e){var t=this.callback,n=function(){try{t.apply(this,arguments)}catch(n){e(n,arguments[0])}};return this.callback=n,this},defer:function(){return this.delay(0)},disposeAfter:function(t){if("number"!=typeof t||t<=0)throw new Error("The value provided to disposeAfter (maxCalls) must be a number greater than zero.");var n=e.after(t,this.unsubscribe.bind(this));return this.pipeline.push(function(e,t,i){i(e,t),n()}),this},distinct:function(){return this.constraint(new d)},distinctUntilChanged:function(){return this.constraint(new b)},invokeSubscriber:function(e,t){if(!this.inactive){var n=this,i=n.pipeline,r=i.length,c=n._context,o=-1,s=!1;if(r){i=i.concat([n.callback]);var a=function u(e,t){o+=1,o<r?i[o].call(c,e,t,u):(n.callback.call(c,e,t),s=!0)};a(e,t,0)}else n.callback.call(c,e,t),s=!0;return s}},logError:function(){if(console){var e;e=console.warn?console.warn:console.log,this["catch"](e)}return this},once:function(){return this.disposeAfter(1)},subscribe:function(e){return this.callback=e,this},unsubscribe:function(){this.inactive||h.unsubscribe(this)},constraint:function(e){if("function"!=typeof e)throw new Error("Predicate constraint must be a function");return this.pipeline.push(function(t,n,i){e.call(this,t,n)&&i(t,n)}),this},constraints:function(t){var n=this;return e.each(t,function(e){n.constraint(e)}),n},context:function(e){return this._context=e,this},debounce:function(t,n){if("number"!=typeof t)throw new Error("Milliseconds must be a number");var i={};return!!n==!0&&(i.leading=!0,i.trailing=!1),this.pipeline.push(e.debounce(function(e,t,n){n(e,t)},t,i)),this},delay:function(e){if("number"!=typeof e)throw new Error("Milliseconds must be a number");var t=this;return t.pipeline.push(function(t,n,i){setTimeout(function(){i(t,n)},e)}),this},throttle:function(t){if("number"!=typeof t)throw new Error("Milliseconds must be a number");var n=function(e,t,n){n(e,t)};return this.pipeline.push(e.throttle(n,t)),this}};var v=(l.resolver={cache:{},regex:{},enableCache:!0,compare:function(t,n,i){var r,c,o,s=n+l.cacheKeyDelimiter+t,a=this.cache[s],u=i||{},h=this.enableCache&&!u.resolverNoCache;return a===!0?a:t.indexOf("#")===-1&&t.indexOf("*")===-1?(a=n===t,h&&(this.cache[s]=a),a):((c=this.regex[t])||(r="^"+e.map(t.split("."),function(e){var t="";return o&&(t="#"!==o?"\\.\\b":"\\b"),t+="#"===e?"[\\s\\S]*":"*"===e?"[^.]+":e,o=e,t}).join("")+"$",c=this.regex[t]=new RegExp(r)),a=c.test(n),h&&(this.cache[s]=a),a)},reset:function(){this.cache={},this.regex={}},purge:function(t){var n=this,i=l.cacheKeyDelimiter,r=function(e,r){var c=r.split(i),o=c[0],s=c[1];"undefined"!=typeof t.topic&&t.topic!==o||"undefined"!=typeof t.binding&&t.binding!==s||delete n.cache[r]},c=function(e,t){var r=t.split(i);0===h.getSubscribersFor({topic:r[0]}).length&&delete n.cache[t]};if("undefined"==typeof t)this.reset();else{var o=t.compact===!0?c:r;e.each(this.cache,o)}}},0),y=[],m=0,g=o.bind(n,"created"),w=o.bind(n,"removed");if(e.extend(h,{cache:{},subscriptions:{},wireTaps:[],ChannelDefinition:f,SubscriptionDefinition:p,channel:function(e){return new f(e,this)},addWireTap:function(e){var t=this;return t.wireTaps.push(e),function(){var n=t.wireTaps.indexOf(e);n!==-1&&t.wireTaps.splice(n,1)}},noConflict:function(){if("undefined"==typeof window||"undefined"!=typeof window&&"function"==typeof define&&define.amd)throw new Error("noConflict can only be used in browser clients which aren't using AMD modules");return t.postal=a,this},getSubscribersFor:function(t){var n=[],i=this;return e.each(i.subscriptions,function(i){e.each(i,function(i){n=n.concat(e.filter(i,s(t,l.resolver)))})}),n},publish:function(t,n){++v;var r=t.channel=t.channel||l.DEFAULT_CHANNEL,o=t.topic;t.timeStamp=new Date,this.wireTaps.length&&e.each(this.wireTaps,function(e){e(t.data,t,v)});var s=r+l.cacheKeyDelimiter+o,a=this.cache[s],u=0,h=0;if(a)e.each(a,function(e){e.invokeSubscriber(t.data,t)?h++:u++});else{var f=c(o,this.cache,s,function(e){e.invokeSubscriber(t.data,t)?h++:u++},t);e.each(this.subscriptions[r],function(t){e.each(t,f)})}0===--v&&i(),n&&n({activated:h,skipped:u})},reset:function(){this.unsubscribeFor(),l.resolver.reset(),this.subscriptions={},this.cache={}},subscribe:function(t){var n,i=this.subscriptions,r=new p(t.channel||l.DEFAULT_CHANNEL,t.topic,t.callback),o=i[r.channel],s=r.channel.length;o||(o=i[r.channel]={}),n=i[r.channel][r.topic],n||(n=i[r.channel][r.topic]=[]),n.push(r);var a=this.cache;return e.each(e.keys(a),function(e){e.substr(0,s)===r.channel&&c(e.split(l.cacheKeyDelimiter)[1],a,e)(r)}),l.enableSystemMessages&&this.publish(g(r)),r},unsubscribe:function(){for(var t,n,i,c,o=arguments.length,s=0;s<o;s++){if(t=arguments[s],t.inactive=!0,v)return void y.push(t);if(n=this.subscriptions[t.channel],i=n&&n[t.topic]){var a=i.length;for(c=0;c<a;){if(i[c]===t){i.splice(c,1);break}c+=1}if(0===i.length&&(delete n[t.topic],e.keys(n).length||delete this.subscriptions[t.channel]),t.cacheKeys&&t.cacheKeys.length)for(var u;u=t.cacheKeys.pop();)e.each(this.cache[u],r(t,u,this.cache));if("function"==typeof l.resolver.purge){var h=l.autoCompactResolver===!0?0:"number"==typeof l.autoCompactResolver&&l.autoCompactResolver-1;h>=0&&m===h?(l.resolver.purge({compact:!0}),m=0):h>=0&&m<h&&(m+=1)}}l.enableSystemMessages&&this.publish(w(t))}},unsubscribeFor:function(e){var t=[];this.subscriptions&&(t=this.getSubscribersFor(e),this.unsubscribe.apply(this,t))}}),t&&Object.prototype.hasOwnProperty.call(t,"__postalReady__")&&e.isArray(t.__postalReady__))for(;t.__postalReady__.length;)t.__postalReady__.shift().onReady(h);return h});